//
//  $Id: AppPreferencesOutputStream.cc,v 1.1.1.1 2000/06/02 22:23:01 sergey Exp $
//

#include <Pilot.h>
#include "AppPreferencesOutputStream.h"


namespace Util
{
    AppPreferencesOutputStream::AppPreferencesOutputStream():
        _creatorID(0),
        _preferencesID(0),
        _appVersion(0)
    {}

    AppPreferencesOutputStream::~AppPreferencesOutputStream()
    {
        close();
    }

    // operations

    void AppPreferencesOutputStream::open(DWord creatorID, Word preferencesID, int appVersion)
    {
        close();

        _creatorID = creatorID;
        _preferencesID = preferencesID;
        _appVersion = appVersion;
    }

    void AppPreferencesOutputStream::close()
    {
        if (_buffer.size() > 0)
        {
            PrefSetAppPreferences(_creatorID, _preferencesID, _appVersion, (void*)_buffer.lock(), _buffer.size(), true);
            _buffer.unlock();

            _buffer.free();
        }
    }

    void AppPreferencesOutputStream::writeData(const void* data, int size)
    {
        if (data != 0 && size > 0)
        {
            int bufSize = _buffer.size();
            void* bufData = _buffer.lock(bufSize+size);

            if (bufData != 0)
                MemMove((Byte*)bufData+bufSize, data, size);

            _buffer.unlock();
        }
    }
}
// namespace Util
